Button = {}

--buttonClick = love.audio.newSource("sound/buttonClick.wav","static")

function Button:new(pos, mousepressed, graphics, textobj, scale)
	local o = {}
	
	o.f = mousepressed
	o.graphics = graphics
	o.graphic = graphics["default"]
	o.pos = pos
	o.rect = Rect:new()
	o.textObj = textobj
	o.scale = scale or Vector2:new(1,1)
	o.type = "Button"
	print("Scaling factors of "..o.scale.x.." and "..o.scale.y)
	
	w, h = o.graphic:getDimensions()
	
	o.rect = Rect:new(pos.x, pos.y, w*o.scale.x, h*o.scale.y)
	o.down = false
	
	if o.textObj then
		
		off = Vector2:new(o.textObj.width, o.textObj.height)/2
		o.textObj.pos = o.rect.center - off
		
	end
	
	print("Created Button at point ")
	print(o.pos)
	
	self.__index = self
	return setmetatable(o, self)
end

function Button:draw()
	love.graphics.setColor(255,255,255)
	
	love.graphics.draw(self.graphic, self.pos.x, self.pos.y, 0, self.scale.x, self.scale.y)
	
	if self.textObj then
		
		self.textObj:draw()
		
	end
	
end


function Button:mousehover(x, y)
	
	if self.rect:contains(Vector2:new(x,y)) then
		if (not self.down) then
			
			self.graphic = self.graphics["over"]
			
		end
	else
		self.graphic = self.graphics["default"]
		self.down = false
	end
end

function Button:mousepressed(x, y, button)
	
	if self.rect:contains(Vector2:new(x,y)) then
		
		self.graphic = self.graphics["down"]
		self.down = true
		--play sound
		
		
	
	else
		
		self.graphic = self.graphics["default"]
		
	end
	
end

function Button:mousereleased(x,y,button)
	
	if self.down then
		self.graphic = self.graphics["over"]
		--buttonClick:stop()
		--buttonClick:play()
			
		self.f(x,y,button)
	
	else
		--We released outside the button
		self.graphic = self.graphics["default"]
	end
	
end


