
-- Credits
-----------
--[[
	NASA - Jupiter Texture
	Strong - Michael Ebens
	anim8 - Kikito
	GubbleBum Font - Jelloween Font foundry

--]] 

credits = {}

function credits:load()
	
	self.credits =
	{
		{"Jupiter Texture", "NASA"},
		{"Strong text parsing", "Michael Ebens"}, -- Never actually used...
		{"anim8", "Kikito"},
		{"GubbleBum Font", "Jelloween Font Foundry"},
	}
	
	self.t = 0
	
end

function credits:onStart()
	
	self.width = love.window.getWidth()
	self.height = love.window.getHeight()
	
	self.center = Vector2(self.width/2, self.height/2)
	
	self.t = 0
	
	self.font = love.graphics.newFont(20)
	
	self.off = 3
	self.sep = " "
	
	self.speed = 35
end

function credits:update(dt)
	self.t = self.t + dt * self.speed
	
	self.pos = Vector2(self.center.x, self.height) - (Vector2(0,1) * self.t)
end

function credits:draw()
	love.graphics.setFont(self.font)
	
	local space1 = " "*self.off
	local space2 = space1
	
	for i, entry in ipairs(self.credits) do
		
		
		w = self.font:getWidth(entry[1]..space1) + self.font:getWidth(self.sep)/2
		
		local pos = Vector2(self.center.x - w, i*self.font:getHeight()*1.5)
		
		pos.y = pos.y + self.pos.y
		love.graphics.print(entry[1]..space1..self.sep..space2..entry[2], pos.x, pos.y)
		
	end
end

RegState("credits", credits)
--RegInitialState("credits")